/*
 * File name: l-b-endian.c
 * Date:      2009/02/01 10:57
 * Author:    valor
 */

/* -- Includes 
 * */
#include <stdio.h>

/* -- Typedefs 
 * */

/* Define a new type for nicer memory operations */
typedef union { 
    unsigned char byte;
    int word;
} t_lbunion;

/* -- Functions 
 * */

/*   Description:
 *      main()
 *   Input:
 *      none
 *   Output:   
 *       0 if little-endian architecture detected
 *      !0 otherwise 
 * */
int main(void) {
    int result;
    t_lbunion u;

    u.word = 0xdeadbeaf;
    result = (u.byte == 0xde);

    printf("Detected architecture: %s-endian\n", (result == 0) ? "little" : "big");

    return result;
}


/* end of l-b-endian.c */
/* vim: set ts=8 sw=4 tw=0 expandtab cindent smartindent: */

